#include <iostream.h>
#include <cstring>
#include "Ifrit_C_FEN.h"
#include "Ifrit_C_Board.h"
#include "Ifrit_C_Rules.h"
#include "Ifrit_C_Move.h"
using namespace std;
//-----------------------------------------------------------------------------------
/* +
 *      fen 
 *
 *  ChessTerminator75
 *   14.1.2007

          
*/
//---------------------------------------------------------------------------

//	===================================================================
//       
void parse_position(char string_in[],int chess_board[]){
   /*const*/ char * fen;
   char * moves;
   /*const*/ char * ptr;
 char move_string[]={' ',' ',' ',' ',' ',' ',' '};  
 char * StartFen = "fen rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1 ";

//    fen
   fen = strstr(string_in,"fen ");
//    moves
   moves = strstr(string_in,"moves ");

   if (fen != NULL) { // "fen" present   
//            
//    
      board_from_fen(chess_board,fen);
   } else {
//      startpos
//            :)
//const char * const StartFen = "fen rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1";
     board_from_fen(chess_board,StartFen);
   }// if (fen != NULL)

   if (moves != NULL) { // "moves" present
      //  moves 
      ptr = moves + 6;

      while (*ptr != '\0') { 
         move_string[1] = *ptr++;
         move_string[2] = *ptr++;
         move_string[3] = *ptr++;
         move_string[4] = *ptr++;

         if (*ptr == '\0' || *ptr == ' ') {
            move_string[5] = '\0';
         } else { // promote
            move_string[5] = *ptr++;
            move_string[6] = '\0';
         }
         board_from_move(chess_board,move_string);
         while (*ptr == ' ') ptr++;
      }//while (*ptr != '\0') {
    }//if (moves != NULL)
fen   = NULL;
moves = NULL;
ptr = NULL;
StartFen = NULL;
}//parse_position(char string_in[]){
//	*******************************************************************

//	===================================================================
//         Ch_Koordinata_To_Indeks
void board_from_fen(int chess_board[],/* const*/ char fen[]){
  int i=0;
// fen
  while (fen[i]!=' '){
	  i=i+1;
  }//while (fen!='\0'){
// void
  while (fen[i]==' '){
	  i=i+1;
  }//while (fen!='\0'){

//-----------------------------------------------------------------------------------	
// 1     -     
int y=1;
int x=1;
int l;
while(fen[i]!=' '){
	x=1;
//--------------------	
	while((fen[i]!='/')&&(fen[i]!=' ')){
	// 0-  1- 2- 3- 4- 5- 6-	
	 switch(fen[i]){
		case 'R':
         xy_board_in(1,x,y,2,chess_board);
         xy_board_in(2,x,y,1,chess_board);
		break;
		case 'N':
         xy_board_in(1,x,y,3,chess_board);
         xy_board_in(2,x,y,1,chess_board);		
		break;
		case 'B':
         xy_board_in(1,x,y,4,chess_board);
         xy_board_in(2,x,y,1,chess_board);
		break;
		case 'Q':
         xy_board_in(1,x,y,5,chess_board);
         xy_board_in(2,x,y,1,chess_board);
		break;
		case 'K':
         xy_board_in(1,x,y,6,chess_board);
         xy_board_in(2,x,y,1,chess_board);
		break;
		case 'P':
         xy_board_in(1,x,y,1,chess_board);
         xy_board_in(2,x,y,1,chess_board);
		break;
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// 0-  1- 2- 3- 4- 5- 6-	
		case 'r':
         xy_board_in(1,x,y,2,chess_board);
         xy_board_in(2,x,y,0,chess_board);
		break;
		case 'n':
         xy_board_in(1,x,y,3,chess_board);
         xy_board_in(2,x,y,0,chess_board);		
		break;
		case 'b':
         xy_board_in(1,x,y,4,chess_board);
         xy_board_in(2,x,y,0,chess_board);
		break;
		case 'q':
         xy_board_in(1,x,y,5,chess_board);
         xy_board_in(2,x,y,0,chess_board);
		break;
		case 'k':
         xy_board_in(1,x,y,6,chess_board);
         xy_board_in(2,x,y,0,chess_board);
		break;
		case 'p':
         xy_board_in(1,x,y,1,chess_board);
         xy_board_in(2,x,y,0,chess_board);
		break;
			
			default:
//    9-...    '8'   8   1 
			l=(9-Ch_Koordinata_To_Indeks(fen[i]));
			xy_board_in(1,x,y,0,chess_board);
            xy_board_in(2,x,y,0,chess_board);
			for (int f=1;f<l;f++){
			 	x=x+1;
			 	xy_board_in(1,x,y,0,chess_board);
                xy_board_in(2,x,y,0,chess_board);
			}//for (int f=1;f<l;f++)
		}// switch(fen[i]){
		
		i=i+1;
		x=x+1;
	}//while((fen[i]!='/')&(fen[i]!=' ')){
//--------------------		

	if(fen[i]!=' ')	{i=i+1;y=y+1;}
	  	
}//while(fen[i]!=' '){

//-----------------------------------------------------------------------------------	
//2     	
// void
  while (fen[i]==' '){
	  i=i+1;
  }//while (fen!='\0'){
	if (fen[i]=='w') {xy_board_in(0,-1,-1,1,chess_board);}
	if (fen[i]=='b') {xy_board_in(0,-1,-1,0,chess_board);}
//	-----------------------------------------------------------------------------------	
//	3   
//	  1 , 0  
//	  1,   2,    3,    4
//	,   5,    6
	// void
	  i=i+2;
//              
	xy_board_in(4,1,-1,1,chess_board);
	xy_board_in(4,2,-1,1,chess_board);
	xy_board_in(4,3,-1,1,chess_board);
	xy_board_in(4,4,-1,1,chess_board);
	xy_board_in(4,5,-1,1,chess_board);
    xy_board_in(4,6,-1,1,chess_board);

	while(fen[i]!=' '){	
		if (fen[i]=='K') {xy_board_in(4,1,-1,0,chess_board);
		xy_board_in(4,4,-1,0,chess_board);}
		if (fen[i]=='Q') {xy_board_in(4,1,-1,0,chess_board);
		xy_board_in(4,3,-1,0,chess_board);}
		if (fen[i]=='k') {xy_board_in(4,2,-1,0,chess_board);
		xy_board_in(4,6,-1,0,chess_board);}
		if (fen[i]=='q') {xy_board_in(4,2,-1,0,chess_board);
		xy_board_in(4,5,-1,0,chess_board);}
		i=i+1;
	}
//	-----------------------------------------------------------------------------------
//	 4     
//	  ( 1 ,  2  ,  3  )
	    // void
  while (fen[i]==' '){
	  i=i+1;
  }//while (fen!='\0'){
//		               
//		        1	 
		xy_board_in(3,1,-1,0,chess_board);
		if (fen[i]!='-'){
			xy_board_in(3,1,-1,1,chess_board);
			xy_board_in(3,2,-1,Koordinata_To_Indeks(fen[i]),chess_board);
			i=i+1;
			xy_board_in(3,3,-1,Ch_Koordinata_To_Indeks(fen[i]),chess_board);	
		}//if (GUI_To_Engine_Text.charAt(i)!='-'){	
//---------------------------------------------------------------------------
}//board_from_fen(int chess_board[], const char fen[]){
//	*******************************************************************

//	===================================================================
//     ..       
void board_from_move(int chess_board[],char move_string[]){
int legal_move[65];
int chess_board_r[138];
for (int x=0 ;x<138;x++){
	  chess_board_r[x]=0;
	}//for (int xv=0 ;xv<138;xv++){
for (int x2=0 ;x2<65;x2++){
	  legal_move[x2]=0;
	}//for (int xv=0 ;xv<138;xv++){


//    
Rules(Koordinata_To_Indeks(move_string[1]),Ch_Koordinata_To_Indeks(move_string[2]),chess_board,legal_move);
int f=0;
Realization_Moves(Koordinata_To_Indeks(move_string[1]),Ch_Koordinata_To_Indeks(move_string[2]),Koordinata_To_Indeks(move_string[3]),Ch_Koordinata_To_Indeks(move_string[4]),chess_board,chess_board_r,legal_move,move_string[5],&f);
//    -------------------------------------------------
	for (int x=0 ;x<138;x++){
	  chess_board[x]=chess_board_r[x];
	}//for (int xv=0 ;xv<138;xv++){
}//void board_from_move(int chess_board[],char move_string){
//	*******************************************************************

//	===================================================================
//	    	
	int Koordinata_To_Indeks(char ch){
			   if (ch =='a') return 1;
			   if (ch =='b') return 2;
			   if (ch =='c') return 3;
			   if (ch =='d') return 4;
			   if (ch =='e') return 5;
			   if (ch =='f') return 6;
			   if (ch =='g') return 7;
			   if (ch =='h') return 8;
			   return 777;
			  }
//	*******************************************************************
//	===================================================================
//	     	
	int Ch_Koordinata_To_Indeks(int ch){
			   if (ch =='1') return 8;
			   if (ch =='2') return 7;
			   if (ch =='3') return 6;
			   if (ch =='4') return 5;
			   if (ch =='5') return 4;
			   if (ch =='6') return 3;
			   if (ch =='7') return 2;
			   if (ch =='8') return 1;
			   return 777;
			  }
//	*******************************************************************
